// ConfigFile.cpp: implementation of the ConfigFile class.
//
//////////////////////////////////////////////////////////////////////

#include "ConfigFile.h"
#include "Utility.h"

#include <string.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ConfigFile::ConfigFile() {
	m_pList = new StringLinkedList<char>();
	m_pCurrentNode = NULL;
}

ConfigFile::~ConfigFile() {
	delete m_pList;
}

int ConfigFile::Open (char* pszFileName) {

	filebuf fbFile;
	fbFile.open (pszFileName, ios::in | ios::nocreate, filebuf::sh_read);

	if (fbFile.is_open() == 0) {
		return ERR;
	} else {

		// Get file length
		struct _stat stFile;
		_stat (pszFileName, &stFile);
		
		char* pszBuffer = new char [stFile.st_size + 1];
		int iLen = fbFile.sgetn (pszBuffer, stFile.st_size);
		pszBuffer [iLen] = '\0';
		fbFile.close();

		char* pszTemp = strtok (pszBuffer, "=");
		char* pszLhs;
		char* pszRhs;
		while (true) {

			// Parse lval
			if (pszTemp == NULL) {
				break;
			}

			pszLhs = new char [strlen (pszTemp) + 1];
			strcpy (pszLhs, pszTemp);

			// Get rhs
			pszTemp = strtok (NULL, "\n");
			pszRhs = new char [strlen (pszTemp) + 1];
			strcpy (pszRhs, pszTemp);

			// Add pair to list
			m_pList->AddElement (pszLhs, pszRhs);

			// Get next lhs
			pszTemp = strtok (NULL, "=");
		}

		m_pCurrentNode = m_pList->m_plnHead;

		delete [] pszBuffer;

		return OK;
	}
}

void ConfigFile::Close() {

	m_pCurrentNode = NULL;
	delete m_pList;
	m_pList = new StringLinkedList<char>();
}

int ConfigFile::GetNextParameter (char** ppszLhs, char** ppszRhs) {
	
	if (m_pCurrentNode == NULL) {
		*ppszLhs = NULL;
		*ppszRhs = NULL;
		return ERR;	
	}
	
	*ppszLhs = m_pCurrentNode->Name;
	*ppszRhs = m_pCurrentNode->Data;
	
	m_pCurrentNode = m_pCurrentNode->Next;
	
	return OK;
}

int ConfigFile::GetParameter (char* pszLhs, char** ppszRhs) {

	StringListNode<char>* pNode = m_pList->m_plnHead;

	while (pNode != NULL) {
		if (strcmp (pszLhs, pNode->Name) == 0) {
			*ppszRhs = pNode->Data;
			return OK;
		}
		pNode = pNode->Next;
	}

	*ppszRhs = NULL;
	return ERR;
}