// File.h: interface for the File class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILE_H__C5064726_A72E_11D1_9C50_0060083E8062__INCLUDED_)
#define AFX_FILE_H__C5064726_A72E_11D1_9C50_0060083E8062__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Utility.h"
#include "Mutex.h"

class File {
private:

	friend class FileCache;

	char* m_pszFileName;
	char* m_pszData;
	char* m_pszMimeType;
	char* m_pszLastModifiedTime;

	int m_iLength;
	int m_iLastModifiedTime;
	bool m_bInMemory;

	int m_iRef;
	Mutex* m_pmMutex;
	
	virtual inline void AddRef();
	virtual inline void Release();
	virtual inline int GetNumRefs();
	virtual inline int GetNumBytes();

public:
	File ();
	virtual ~File();

	virtual int Open (char* pszFileName);
	virtual void Close();
	virtual void Delete();
	virtual int GetLength() const;
	virtual char* GetMimeType() const;
	void SetMimeType (char* pszMimeType);
	virtual char* GetName() const;
	virtual char* GetLastModifiedTime() const;
	virtual int GetLastModifiedIntTime() const;
	virtual char* GetData() const;
	virtual int ReadData (void** ppState, char* pszBuffer, int iNumBytes) const;

	static void GetAllFileNames (char* pszSpec, int* piNumFiles, char*** pppszFileName);
};

#endif // !defined(AFX_FILE_H__C5064726_A72E_11D1_9C50_0060083E8062__INCLUDED_)
