// HttpResponse.h: interface for the HttpResponse class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HTTPRESPONSE_H__FE4EBF35_AE05_11D1_9C62_0060083E8062__INCLUDED_)
#define AFX_HTTPRESPONSE_H__FE4EBF35_AE05_11D1_9C62_0060083E8062__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Utility.h"

class HttpResponse {

	friend class HttpServer;

private:
	
	bool m_bOverride;
	int m_iType;
	int m_iStatus;
	int m_iLength;

	char* m_pszResponseData;
	char* m_pszFileName;
	char* m_pszMimeType;
	char* m_pszRedirectUri;

	int m_iNumCookiesSet;
	int m_iSetCookieSpace;
	char** m_ppszCookieSetName;
	char** m_ppszCookieSetValue;
	char** m_ppszCookieSetPath;
	int* m_piCookieTTL;

	int m_iNumCookiesDel;
	int m_iDelCookieSpace;
	char** m_ppszCookieDelName;
	char** m_ppszCookieDelPath;
	
	virtual inline bool Override();
	virtual inline int GetType();
	virtual inline int GetStatus();
	virtual inline char* GetData();
	virtual inline int GetLength();
	virtual inline char* GetFileName();
	virtual inline char* GetMimeType();
	virtual inline char* GetRedirectUri();

	virtual inline int GetNumCookiesSet();
	virtual inline int GetNumCookiesDeleted();
	virtual void GetCookiesSet (char*** pppszCookieName, char*** pppszCookieValue, int** ppiTTLinSeconds, 
		char*** pppszCookiePath);
	virtual void GetCookiesDeleted (char*** pppszCookieName, char*** pppszCookiePath);

public:

	HttpResponse();
	virtual ~HttpResponse();
	
	virtual inline void SetOverride (bool bOverride);
	virtual inline void SetType (int iType);
	virtual inline void SetStatus (int iStatus);
	
	virtual inline void SetData (char* pszData, int iLength);
	virtual inline void SetData (char* pszData);
	virtual inline void ClearData();
	virtual inline void WriteData (char* pszData);
	virtual inline void WriteData (char* pszData, int iLength);

	virtual inline void SetFileName (char* pszFileName);
	virtual inline void SetMimeType (char* pszMimeType);
	virtual inline void SetRedirectUri (char* pszRedirectUri);
	
	virtual int SetCookie (char* pszCookieName, char* pszCookieValue, int iTTLinSeconds, char* pszCookiePath);
	virtual int DeleteCookie (char* pszCookieName, char* pszCookiePath);
};

#endif // !defined(AFX_HTTPRESPONSE_H__FE4EBF35_AE05_11D1_9C62_0060083E8062__INCLUDED_)