#include <objbase.h>

typedef struct HttpRequestData {

	// Request information
	int iMethod;
	int iVersion;
	char* pszUri;
	char* pszFileName;

	// Client information
	char* pszBrowserName;
	char* pszIPAddress;
	char* pszDomainName;
	char* pszHostName;
	
	// Authentication
	char* pszLogin;
	char* pszPassword;

	// Forms
	int iNumForms;
	char** ppszFormName;
	char** ppszFormValue;
	char** ppszFormFileName;
	int* piFormType;

	// Cookies
	int m_iNumCookies;
	char** m_ppszCookieName;
	char** m_ppszCookieValue;

} HttpRequestData;


typedef struct HttpResponseData {

	bool bOverride;
	int iType;
	int iStatus;
	int iLength;

	char* pszResponseData;
	char* pszFileName;
	char* pszMimeType;
	char* pszRedirectUri;
	char* pszLastModified;

	int iNumCookiesSet;
	int iSetCookieSpace;
	char** ppszCookieSetName;
	char** ppszCookieSetValue;
	char** ppszCookieSetPath;
	int* piCookieTTL;

	int iNumCookiesDel;
	int iDelCookieSpace;
	char** ppszCookieDelName;
	char** ppszCookieDelPath;

} HttpResponseData;


interface IPageSource : IUnknown {

	// IUnknown
/*	virtual HRESULT __stdcall QueryInterface (const IID& iid, void** ppv);
	virtual ULONG __stdcall AddRef();
	virtual ULONG __stdcall Release();
	virtual IUnknown* CreateInstance(); */

	// PageSource
	virtual bool __stdcall OnBasicAuthenticate (char* pszLogin, char* pszPassword) = 0;
	virtual int __stdcall OnGet (HttpRequestData* pHttpRequest, HttpResponseData* pHttpResponse) = 0;
	virtual int __stdcall OnPost (HttpRequestData* pHttpRequest, HttpResponseData* pHttpResponse) = 0;
};


// {914F276B-CC45-11d1-9D04-0060083E8062}
static const IID IID_IPageSource = 
{ 0x914f276b, 0xcc45, 0x11d1, { 0x9d, 0x4, 0x0, 0x60, 0x8, 0x3e, 0x80, 0x62 } };
