#include "HttpServer.h"
#include "Utility.h"

int WinsockOpen();
int WinsockClose();

void __cdecl main() {

	// Open winsock library
	if (WinsockOpen() != 0) {
		printf ("Could not initialize socket library!\n");
		return;
	}

	// Create new web server object
	HttpServer* pHttpDaemon = new HttpServer();

	// Start web server
	printf ("Starting Server...");
	pHttpDaemon->Start();
	printf ("started");

	getchar();

	printf ("Terminating Server...");
	pHttpDaemon->Stop();
	delete pHttpDaemon;
	printf ("terminated\n");

	// Close winsock library
	WinsockClose();
}


int WinsockOpen() {
	
	WSADATA wsaData;
	
	WORD wVersionRequested = MAKEWORD (2, 0);
	int iErrorCode = WSAStartup (wVersionRequested, &wsaData);
	
	if (iErrorCode != 0) {
		return -1;
	}
	
	if (LOBYTE (wsaData.wVersion) != 2 || HIBYTE (wsaData.wVersion) != 0) {
		WSACleanup();
		return -1;
	}

	return 0;
}

int WinsockClose() {

	int iErrCode = WSACleanup();

	if (iErrCode == SOCKET_ERROR) {
		return WSAGetLastError();
	}

	return 0;
}