// Mutex.h: interface for the Mutex class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MUTEX_H__93D4C495_ABB4_11D1_9C5E_0060083E8062__INCLUDED_)
#define AFX_MUTEX_H__93D4C495_ABB4_11D1_9C5E_0060083E8062__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <windows.h>

class Mutex {

private:

	HANDLE m_hMutex;

public:
	
	Mutex() {
		m_hMutex = ::CreateMutex (NULL, FALSE, NULL);
	}

	virtual ~Mutex() {
		::CloseHandle (m_hMutex);
	}

	virtual inline void WaitForSingleObject() {
		::WaitForSingleObject (m_hMutex, INFINITE);
	}
	
	virtual inline void ReleaseMutex() {
		::ReleaseMutex (m_hMutex);
	}
	
	static inline void SpinLock() { ::Sleep (10); }
};

#endif // !defined(AFX_MUTEX_H__93D4C495_ABB4_11D1_9C5E_0060083E8062__INCLUDED_)
