// ServerSocket.h: interface for the ServerSocket class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVERSOCKET_H__E0FAE59D_A3F7_11D1_9C48_0060083E8062__INCLUDED_)
#define AFX_SERVERSOCKET_H__E0FAE59D_A3F7_11D1_9C48_0060083E8062__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <winsock2.h>
#include "Utility.h"

class ServerSocket {

public:
	ServerSocket();
	virtual ~ServerSocket();

	virtual int Open();
	virtual int Listen (short siPort);
	virtual ServerSocket* Accept();
	virtual int RecvRequest();
	virtual char* GetNextLine();
	virtual char* GetNextLine (int* piNumBytes);
	virtual inline char* GetClientIP();
	virtual inline char* GetClientDomainName();
	virtual inline int Send (char* pszData);
	virtual inline int Send (char* pszData, int iNumBytes);
	virtual int Close();
	virtual inline bool Alive();
	virtual inline char* GetData();
	virtual inline char* GetRemainingData();
	virtual inline int GetNumRemainingBytes();
	virtual inline int GetNumBytes();
	virtual inline void SetPosition (int iPos);

private:

	// Internal socket
	SOCKET m_Socket;
	
	// Ports
	short m_siOurPort;
	short m_siTheirPort;

	// Addresses
	struct sockaddr_in m_saOurAddr;
	struct sockaddr_in m_saTheirAddr;

	// Their data
	char* m_pszTheirIP;
	char* m_pszTheirHostName;

	// Buffer in which the current line of data is placed
	char* m_pszOutputBuffer;

	// Buffer in which incoming requests are placed
	char* m_pszBuffer;

	// Current position in input buffer
	int m_iPos;

	// Length of input buffer
	int m_iLen;

	// Return last socket error
	virtual inline int GetLastError();
};

#endif // !defined(AFX_SERVERSOCKET_H__E0FAE59D_A3F7_11D1_9C48_0060083E8062__INCLUDED_)
