// TempFile.cpp: implementation of the TempFile class.
//
//////////////////////////////////////////////////////////////////////

#include "TempFile.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TempFile::TempFile() {

	// Get temp directory
	char pszTempDir [MAX_PATH];

	m_pszFileName  = new char [MAX_PATH];	
	
	::GetEnvironmentVariable ("TEMP", pszTempDir, MAX_FILENAME_LENGTH * sizeof (char));

	if (::GetTempFileName (pszTempDir, "Alajar", 0, m_pszFileName) == 0) {
		_ASSERT (false);
	}
}

TempFile::~TempFile() {
	delete [] m_pszFileName;
}

void TempFile::Open() {
	pfFile = new filebuf();
	pfFile->open (m_pszFileName, ios::out | ios::binary, filebuf::sh_none);
}

void TempFile::Close() {
	pfFile->close();
}

void TempFile::Write (char* pszData, int iLength) {
	pfFile->sputn (pszData, iLength);
}

void TempFile::Write (char* pszData) {
	pfFile->sputn (pszData, strlen (pszData));
}

char* TempFile::GetName() {
	return m_pszFileName;
}

void TempFile::Delete() {
	::DeleteFile (m_pszFileName);
}