#include "Utility.h"

namespace Utility {

	int HexToDec (char szDigit) {
		
		switch (szDigit) {
			
		case ('0'):
			return 0;
		case ('1'):
			return 1;
		case ('2'):
			return 2;
		case ('3'):
			return 3;
		case ('4'):
			return 4;
		case ('5'):
			return 5;
		case ('6'):
			return 6;
		case ('7'):
			return 7;
		case ('8'):
			return 8;
		case ('9'):
			return 9;
		case ('a'):
		case ('A'):
			return 10;
		case ('b'):
		case ('B'):
			return 11;
		case ('c'):
		case ('C'):
			return 12;
		case ('d'):
		case ('D'):
			return 13;
		case ('e'):
		case ('E'):
			return 14;
		case ('f'):
		case ('F'):
			return 15;
		default:
			return -1;
		}
	}

	char* WWWEscapeCharToAscii (char* pszInput) {
		
		if (pszInput == NULL) {
			return NULL;
		}
		
		int i, iCurPos = 0, iLength = strlen (pszInput);
		char szCharacter;
		char* pszNewString = new char [iLength + 1];
		
		for (i = 0; i < iLength; i ++) {
			
			if (pszInput[i] == '%' && i + 2 < iLength) {
				szCharacter = (char) (HexToDec (pszInput[i + 1]) * 16 + HexToDec (pszInput [i + 2]));
				
				switch (szCharacter) {
				case '%':
					pszNewString[iCurPos] = '%';
					iCurPos ++;
					pszNewString[iCurPos] = '%';
					break;
					
				case '\\':
					pszNewString[iCurPos] = '\\';
					iCurPos ++;
					pszNewString[iCurPos] = '\\';
					break;
					
				default:
					pszNewString[iCurPos] = szCharacter;
					break;
				}
				
				i += 2;
			} else {
				
				if (pszInput[i] == '+') {
					pszNewString[iCurPos] = ' ';
				} else {
					pszNewString[iCurPos] = pszInput[i];
				}
			}
			
			iCurPos ++;
		}
		
		// Null cap
		pszNewString[iCurPos] = '\0';
		
		return pszNewString;
	}
	
	
	char* SlashToWhack (char* pszInput) {
		
		if (pszInput == NULL) {
			return NULL;
		}
		
		int i, iCurPos = 0, iLength = strlen (pszInput);
		
		char* pszNewString = new char [iLength + 1];
		
		for (i = 0; i < iLength; i ++) {
			
			if (pszInput[i] == '/') {
				pszNewString[iCurPos] = '\\';
			} else {
				pszNewString[iCurPos] = pszInput[i];
			}
			
			iCurPos ++;
		}
		
		pszNewString [iCurPos] = '\0';
		
		return pszNewString;
	}

	char* SlashToUnderscore (char* pszInput) {
		
		if (pszInput == NULL) {
			return NULL;
		}
		
		int i, iCurPos = 0, iLength = strlen (pszInput);
		
		char* pszNewString = new char [iLength + 1];
		
		for (i = 0; i < iLength; i ++) {
			
			if (pszInput[i] == '/') {
				pszNewString[iCurPos] = '_';
			} else {
				pszNewString[iCurPos] = pszInput[i];
			}
			
			iCurPos ++;
		}
		
		pszNewString [iCurPos] = '\0';
		
		return pszNewString;
	}
	
	char* GetMimeType (char* pszFileName) {

		if (pszFileName == NULL || strlen (pszFileName) == 0) {
			return NULL;
		}
		
		char pszTemp [MAX_FILENAME_LENGTH];
		
		// Get file's extension
		sprintf (pszTemp, pszFileName);
		char* pszExtension = _strrev (pszTemp);
		pszExtension = strtok (pszExtension, ".");
		pszExtension = _strrev (pszExtension);

		char* pszType;

		// Check standard types first
		switch (pszExtension[0]) {

		case 'h':
		case 'H':
			
			if (stricmp (pszExtension, "html") == 0 || stricmp (pszExtension, "htm") == 0) {
				pszType = new char [10];
				sprintf (pszType, "text/html");
				return pszType;
			}
		
			break;

		case 'g':
		case 'G':
			if (stricmp (pszExtension, "gif") == 0) {
				pszType = new char [10];
				sprintf (pszType, "image/gif");
				return pszType;
			}
			
			break;

		case 'j':
		case 'J':
			if (stricmp (pszExtension, "jpg") == 0) {
				pszType = new char [11];
				sprintf (pszType, "image/jpeg");
				return pszType;
			}
			
			break;

		case 't':
		case 'T':
			if (stricmp (pszExtension, "txt") == 0 || stricmp (pszExtension, "text") == 0) {
				pszType = new char [11];
				sprintf (pszType, "text/plain");
				return pszType;
			}
			break;

		case 'z':
		case 'Z':
			if (stricmp (pszExtension, "zip") == 0) {
				pszType = new char [29];
				sprintf (pszType, "application/x-zip-compressed");
				return pszType;
			}

			break;

		default:
			break;
		}
		
		// If not a standard type, look for content type in registry
		char* pszKeyName = new char [strlen (pszExtension) + 2];
		sprintf (pszKeyName, ".");
		strcat (pszKeyName, pszExtension);
		
		char pszContentType [] = "Content Type";

		BYTE* pszRegInfo = new BYTE [MAX_MIME_TYPE_LENGTH];
		DWORD dwTypeLen;
		HKEY hKey;
		LONG lErrCode = ::RegOpenKeyEx (HKEY_CLASSES_ROOT, pszKeyName, 0, KEY_QUERY_VALUE, &hKey);
		lErrCode = ::RegQueryValueEx (hKey, pszContentType, NULL, NULL, pszRegInfo, &dwTypeLen);
		::RegCloseKey (hKey);

		// If not found in the registry, default to plaintext
		if (lErrCode != ERROR_SUCCESS) {
			pszType = new char [11];
			sprintf ((char*) pszType, "text/plain");
		} else {
			pszType = new char [strlen ((char*) pszRegInfo) + 1];
			sprintf (pszType, (char*) pszRegInfo);
		}
		
		delete [] pszKeyName;
		delete [] pszRegInfo;
		
		return pszType;
	}
	
	char* GetDateStringGMT() {
		SYSTEMTIME stTime;
		::GetSystemTime (&stTime);
		char* pszRetVal = GetDateString (&stTime);
		strcat (pszRetVal, " GMT");
		return pszRetVal;
	}

	char* GetDateStringLocal() {
		SYSTEMTIME stTime;
		::GetLocalTime (&stTime);
		return GetDateString (&stTime);
	}

	void Sleep (int iMilliSeconds) {
		::Sleep (iMilliSeconds);
	}
	
	long GetTime() {
		return time (NULL);
	}
	
	char* GetTimeStringGMT() {

		SYSTEMTIME stTime;
		::GetSystemTime (&stTime);

		char* pszDate = new char [50];
		char pszTemp [512];

		if (stTime.wHour > 9) {
			sprintf (pszTemp, "%i:", stTime.wHour);
		} else {
			sprintf (pszTemp, "0%i:", stTime.wHour);
		}
		sprintf (pszDate, pszTemp);
		
		if (stTime.wMinute > 9) {
			sprintf (pszTemp, "%i:", stTime.wMinute);
		} else {
			sprintf (pszTemp, "0%i:", stTime.wMinute);
		}
		strcat (pszDate, pszTemp);
		
		if (stTime.wSecond > 9) {
			sprintf (pszTemp, "%i", stTime.wSecond);
		} else {
			sprintf (pszTemp, "0%i", stTime.wSecond);
		}
		strcat (pszDate, pszTemp);

		strcat (pszDate, " GMT");

		return pszDate;
	}

	char* GetTimeStringLocal() {

		SYSTEMTIME stTime;
		::GetLocalTime (&stTime);

		char* pszDate = new char [50];
		char pszTemp [512];

		if (stTime.wHour > 9) {
			sprintf (pszTemp, "%i:", stTime.wHour);
		} else {
			sprintf (pszTemp, "0%i:", stTime.wHour);
		}
		sprintf (pszDate, pszTemp);
		
		if (stTime.wMinute > 9) {
			sprintf (pszTemp, "%i:", stTime.wMinute);
		} else {
			sprintf (pszTemp, "0%i:", stTime.wMinute);
		}
		strcat (pszDate, pszTemp);
		
		if (stTime.wSecond > 9) {
			sprintf (pszTemp, "%i", stTime.wSecond);
		} else {
			sprintf (pszTemp, "0%i", stTime.wSecond);
		}
		strcat (pszDate, pszTemp);

		return pszDate;
	}

	char* GetDateString (SYSTEMTIME* pstTime) {
		
		char* pszDate = new char [100];
		char pszTemp [512];

		switch (pstTime->wDayOfWeek) {
	
		case 0:
			sprintf (pszDate, "Sun, ");
			break;
			
		case 1:
			sprintf (pszDate, "Mon, ");
			break;
			
		case 2:
			sprintf (pszDate, "Tue, ");
			break;
			
		case 3:
			sprintf (pszDate, "Wed, ");
			break;
			
		case 4:
			sprintf (pszDate, "Thu, ");
			break;
			
		case 5:
			sprintf (pszDate, "Fri, ");
			break;
			
		case 6:
			sprintf (pszDate, "Sat, ");
			break;
			
		default:
			sprintf (pszDate, "ERR, ");
			break;
		}
		
		if (pstTime->wDay > 9) {
			sprintf (pszTemp, "%i", pstTime->wDay);
		} else {
			sprintf (pszTemp, "0%i", pstTime->wDay);
		}
		strcat (pszDate, pszTemp);
		
		switch (pstTime->wMonth) {
			
		case 1:
			strcat (pszDate, " Jan ");
			break;
			
		case 2:
			strcat (pszDate, " Feb ");
			break;
			
		case 3:
			strcat (pszDate, " Mar ");
			break;
			
		case 4:
			strcat (pszDate, " Apr ");
			break;
			
		case 5:
			strcat (pszDate, " May ");
			break;
			
		case 6:
			strcat (pszDate, " Jun ");
			break;
			
		case 7:
			strcat (pszDate, " Jul ");
			break;
			
		case 8:
			strcat (pszDate, " Aug ");
			break;
			
		case 9:
			strcat (pszDate, " Sep ");
			break;
			
		case 10:
			strcat (pszDate, " Oct ");
			break;
			
		case 11:
			strcat (pszDate, " Nov ");
			break;
			
		case 12:
			strcat (pszDate, " Dec ");
			break;
			
		default:
			strcat (pszDate, " ERR ");
			break;
		}
		
		sprintf (pszTemp, "%i ", pstTime->wYear);
		strcat (pszDate, pszTemp);

		if (pstTime->wHour > 9) {
			sprintf (pszTemp, "%i:", pstTime->wHour);
		} else {
			sprintf (pszTemp, "0%i:", pstTime->wHour);
		}
		strcat (pszDate, pszTemp);
		
		if (pstTime->wMinute > 9) {
			sprintf (pszTemp, "%i:", pstTime->wMinute);
		} else {
			sprintf (pszTemp, "0%i:", pstTime->wMinute);
		}
		strcat (pszDate, pszTemp);
		
		if (pstTime->wSecond > 9) {
			sprintf (pszTemp, "%i", pstTime->wSecond);
		} else {
			sprintf (pszTemp, "0%i", pstTime->wSecond);
		}
		strcat (pszDate, pszTemp);

		return pszDate;
	}

	char* GetDayOfWeekString() {

		const long lTime = time (NULL);
		struct tm* ptmTime = gmtime (&lTime);

		char* pszRetVal = new char [10];

		switch (ptmTime->tm_wday) {
		case 0:
			sprintf (pszRetVal, "Sunday");
			return pszRetVal;
		case 1:
			sprintf (pszRetVal, "Monday");
			return pszRetVal;
		case 2:
			sprintf (pszRetVal, "Tuesday");
			return pszRetVal;
		case 3:
			sprintf (pszRetVal, "Wednesday");
			return pszRetVal;
		case 4:
			sprintf (pszRetVal, "Thursday");
			return pszRetVal;
		case 5:
			sprintf (pszRetVal, "Friday");
			return pszRetVal;
		case 6:
			sprintf (pszRetVal, "Saturday");
			return pszRetVal;
		default:
			sprintf (pszRetVal, "ERROR");
			return pszRetVal;
		}
	}

	int GetFileAttributes (char* pszFileName) {
		
		if ((::GetFileAttributes (pszFileName) & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY) {
			return FILE_IS_DIRECTORY;
		} else {
			return FILE_IS_FILE;
		}
	}

	bool ModifiedSince (char* pszFileName, char* pszGMTDate, char** ppszLastModified) {

		WIN32_FIND_DATA fdData;
		SYSTEMTIME stFileTime;
		HANDLE hFile = ::FindFirstFile (pszFileName, &fdData);

		if (hFile == INVALID_HANDLE_VALUE) {
			return true;
		}

		::FileTimeToSystemTime (&fdData.ftLastWriteTime, &stFileTime);
		::FindClose (hFile);

		// Save last modified date
		*ppszLastModified = GetDateString (&stFileTime);

		// Compare to sent date
		int iYear, iDay, iHour, iMinute, iSecond;
		char pszMonth [20];
		char pszWeekDay [20];
		sscanf (pszGMTDate, "%s %i %s %i %i:%i:%i", pszWeekDay, &iDay, pszMonth, &iYear, &iHour, &iMinute, &iSecond);

		// Year
		if (stFileTime.wYear != iYear) {
			return (stFileTime.wYear > iYear);
		}

		// Month
		int iMonth = 0;
		switch (pszMonth[0]) {

		case 'J':
		case 'j':
			if (stricmp (pszMonth, "Jan") == 0) {
				iMonth = 0;
			}
			else if (stricmp (pszMonth, "Jun") == 0) {
				iMonth = 5;
			}
			else if (stricmp (pszMonth, "Jul") == 0) {
				iMonth = 6;
			}
			break;

		case 'F':
		case 'f':
			if (stricmp (pszMonth, "Feb") == 0) {
				iMonth = 1;
			}
			break;

		case 'M':
		case 'm':
			if (stricmp (pszMonth, "Mar") == 0) {
				iMonth = 2;
			}
			else if (stricmp (pszMonth, "May") == 0) {
				iMonth = 4;
			}

			break;

		case 'A':
		case 'a':
			if (stricmp (pszMonth, "Apr") == 0) {
				iMonth = 3;
			}
			else if (stricmp (pszMonth, "Aug") == 0) {
				iMonth = 7;
			}
			break;

		case 'S':
		case 's':
			if (stricmp (pszMonth, "Sep") == 0) {
				iMonth = 8;
			}
			break;

		case 'O':
		case 'o':
			if (stricmp (pszMonth, "Oct") == 0) {
				iMonth = 9;
			}
			break;

		case 'N':
		case 'n':
			if (stricmp (pszMonth, "Nov") == 0) {
				iMonth = 10;
			}
			break;

		case 'D':
		case 'd':
			if (stricmp (pszMonth, "Dec") == 0) {
				iMonth = 11;
			}
			break;

		default:
			break;
		}

		if (stFileTime.wMonth != iMonth) {
			return (stFileTime.wMonth > iMonth);
		}

		// Day
		if (stFileTime.wDay != iDay) {
			return (stFileTime.wDay > iDay);
		}

		// Hour
		if (stFileTime.wHour != iHour) {
			return (stFileTime.wHour> iHour);
		}

		// Minute
		if (stFileTime.wMinute != iMinute) {
			return (stFileTime.wMinute> iMinute);
		}

		// Second 
		if (stFileTime.wSecond != iSecond) {
			return (stFileTime.wSecond> iSecond);
		}

		return false;
	}

	
	bool DoesFileExist (char* pszFileName) {

		bool bRetVal;

		WIN32_FIND_DATA pfdData;
		HANDLE hHandle = ::FindFirstFile (pszFileName, &pfdData);

		bRetVal = !(hHandle == INVALID_HANDLE_VALUE);
		if (bRetVal) {
			::FindClose (hHandle);
		}

		return bRetVal;
	}

	wchar_t* CharToWChar (char* pszString) {

		int iLength = strlen (pszString);

		wchar_t* pwszRetVal = new wchar_t [iLength + 2];
		mbstowcs (pwszRetVal, pszString, iLength + 1);

		return pwszRetVal;
	}

	char* WCharToChar (wchar_t* pwszString) {

		int iLength = wcslen (pwszString);

		char* pszRetVal = new char [iLength + 2];
		wcstombs (pszRetVal, pwszString, iLength + 1);

		return pszRetVal;
	}

	int AppendString (char** ppszBuffer, char* pszNewString, int iTotalLength) {

		int iNewLength, iNewStringLength = strlen (pszNewString);

		if (*ppszBuffer == NULL || iTotalLength == 0) {
			*ppszBuffer = new char [iNewStringLength + 1];
			memcpy (*ppszBuffer, pszNewString, sizeof (char) * iNewStringLength);
			(*ppszBuffer)[iNewStringLength] = '\0';
			iNewLength = iNewStringLength;
		} else {
			int iOldLength = strlen (*ppszBuffer);
			iNewLength = iOldLength + iNewStringLength;
			if (iNewLength >= iTotalLength) {
				char* pszTemp = new char [iNewLength + 1];
				memcpy (pszTemp, *ppszBuffer, sizeof (char) * iOldLength);
				memcpy (&pszTemp[iOldLength], pszNewString, sizeof (char) * iNewStringLength);
				pszTemp[iNewLength] = '\0';
				delete *ppszBuffer;
				*ppszBuffer = pszTemp;
			} else {
				memcpy (&((*ppszBuffer)[iOldLength]), pszNewString, sizeof (char) * iNewStringLength);
				(*ppszBuffer)[iNewLength] = '\0';
			}
		}

		return iNewLength;
	}

	void DecodeBase64 (char* pszBase64, char** ppszAnsi) {
		
		int i, j, iVal, iLength = strlen (pszBase64), iNumChars = 0;
		int piResult [4];
		int piFinal [3];

		int i8bitMask = 0x000000FF;
		int i56Mask = 0x00000030;
		int i34Mask = 0x0000000C;

		*ppszAnsi = new char [iLength + 1];

		for (i = 0; i < iLength; i += 4) {

			// Convert from base64 alphabet to 4 32 bit values
			for (j = 0; j < 4; j ++) {

				iVal = (int) pszBase64[i + j];

				// Uppercase
				if (iVal > 64 && iVal < 91) {
					piResult[j] = iVal - 65;
				}

				// Lowercase
				else if (iVal > 96 && iVal < 123) {
					piResult[j] = iVal - 71;
				}

				// Digit
				else if (iVal > 47 && iVal < 58) {
					piResult[j] = iVal + 4;
				}

				// +
				else if (iVal == 43) {
					piResult[j] = 62;
				}

				// /
				else if (iVal == 47) {
					piResult[j] = 63;
				}

				else if (iVal == 61) {
					piResult[j] = 64;
				}
			}
		
			piFinal[0] = (piResult[0] << 2) + ((piResult[1] & i56Mask) >> 4);

			if (pszBase64[i + 2] == '=') {
				piFinal[1] = -1;
				piFinal[2] = -1;
			} else {
				piFinal[1] = ((piResult[1] << 4) & i8bitMask) + ((piResult[2] >> 2) & i8bitMask);
			
				if (pszBase64[i + 3] == '=') {
					piFinal[2] = -1;
				} else {
					piFinal[2] = ((piResult[2] << 6) & i8bitMask) + piResult[3];
				}
			}

			(*ppszAnsi) [iNumChars] = (char) piFinal[0];
			
			if (piFinal[1] == -1) {
				(*ppszAnsi) [iNumChars + 1] = '\0';
			} else {
				(*ppszAnsi) [iNumChars + 1] = (char) piFinal[1];

				if (piFinal[2] == -1) {
					(*ppszAnsi) [iNumChars + 2] = '\0';
				} else {
					(*ppszAnsi) [iNumChars + 2] = (char) piFinal[2];
					(*ppszAnsi) [iNumChars + 3] = '\0';
				}
			}

			iNumChars += 3;
		}
	}

	char* GetOSVersion() {

		OSVERSIONINFO osVer;
		osVer.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);

		::GetVersionEx (&osVer);

		char* pszVer = new char [1024];

		switch (osVer.dwPlatformId) {

		case VER_PLATFORM_WIN32s:
			sprintf (pszVer, "Windows 3.1 with Win32s");
			break;
		case VER_PLATFORM_WIN32_WINDOWS:
			sprintf (pszVer, "Windows 95 Build %s", osVer.szCSDVersion);
			break;
		case VER_PLATFORM_WIN32_NT:
			sprintf (pszVer, "Windows NT %i.%i %s (Build %i)", osVer.dwMajorVersion, osVer.dwMinorVersion, 
				osVer.szCSDVersion, osVer.dwBuildNumber);
			break;
		default:
			sprintf (pszVer, "Unknown OS ");
			break;
		}

		return pszVer;
	}
}
