#include "Main.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

/*

Start with <% Includes, defines, etc. %>

*/

#define BUFFER 1024
char pszBuffer [BUFFER];
int iPos = 0;
int iFileSize;
FILE* fWrite;

char pszOpen [] = "<%";
char pszClose [] = "%>";
int iOpenLength;
int iCloseLength;
int iIndentLevel;

void main() {

	char pszMethodName [] = "RenderTest";
	char pszAsfName [] = "Test.asf";
	char pszTxtName [] = "Test.cpp";
	
	// Init
	FILE* fp = fopen (pszAsfName, "r");
	fWrite = fopen (pszTxtName, "w");

	if (fp == NULL || fWrite == NULL) {
		fprintf (stderr, "Error opening file\n");
		exit (-1);
	}

	iFileSize = fread (pszBuffer, sizeof (char), BUFFER, fp);
	
	iOpenLength = strlen (pszOpen);
	iCloseLength = strlen (pszClose);
	iIndentLevel = 0;

	char* pszTemp = NULL;

	// Make sure the file has content
	if ((pszTemp = GetNextCharacter()) == NULL) {
		fprintf (stderr, "File is empty\n");
		exit (-1);
	}

	// Write system includes
	fprintf (fWrite, "#include \"HttpRequest.h\"\n#include \"HttpResponse.h\"\n");

	// Check for include section
	if (strncmp (pszTemp, pszOpen, iOpenLength) == 0) {
		WriteCodeBlock();
	}

	// Write function prototype
	fprintf (fWrite, "\n\nint %s (HttpRequest* pHttpRequest, HttpResponse* pHttpResponse) {\n", pszMethodName);
	
	iIndentLevel = 1;

	while (iPos < iFileSize) {

		// Write HTML block
		WriteHTMLBlock();

		if (iPos < iFileSize) {
			WriteCodeBlock();
		}
	}

	// Close file
	fprintf (fWrite, "\n}");
	fclose (fWrite);
}


char* GetNextCharacter() {

	while (iPos < iFileSize) {
		if (pszBuffer[iPos] != ' ' && 
			pszBuffer[iPos] != '\t' &&
			pszBuffer[iPos] != '\n' &&
			pszBuffer[iPos] !=  '\r') {
			return &(pszBuffer[iPos]);
		}

		iPos ++;
	}

	return NULL;
}

void WriteCodeBlock() {

	iPos += iOpenLength;

	GetNextCharacter();

	bool bIndented = false;

	while (iPos < iFileSize) {
		if (strncmp (&(pszBuffer[iPos]), pszClose, iCloseLength) == 0) {
			iPos += iCloseLength;
			return;
		}
		
		switch (pszBuffer[iPos]) {
			
		case '{':
			iIndentLevel ++;
			
			if (!bIndented) {
				WriteIndent();
				bIndented = true;
			}

			fprintf (fWrite, "{");
			break;
			
		case '}':
			iIndentLevel --;

			if (!bIndented) {
				WriteIndent();
				bIndented = true;
			}

			fprintf (fWrite, "}");
			break;
			
		default:
			
			if (!bIndented) {
				WriteIndent();
				bIndented = true;
			}

			fprintf (fWrite, "%c", pszBuffer[iPos]);
			break;
		}

		iPos ++;
	}
}

void WriteIndent() {

	fprintf (fWrite, "\n");
	for (int i = 0; i < iIndentLevel; i ++) {
		fprintf (fWrite, "\t");
	}
}

char* FindNextCodeBlock() {

	int iLocalPos = iPos;

	while (iLocalPos < iFileSize) {
		if (strncmp (&(pszBuffer[iLocalPos]), pszOpen, iOpenLength) == 0) {
			return &(pszBuffer[iLocalPos]);
		}

		iLocalPos ++;
	}
	
	return NULL;
}

void WriteHTMLBlock() {
	
	char* pszOpen;

	WriteIndent();
	fprintf (fWrite, "pHttpResponse->WriteData (\"");

	if ((pszOpen = FindNextCodeBlock()) == NULL) {
		
		while (iPos < iFileSize) {
			
			switch (pszBuffer[iPos]) {
			case '\n':
				fprintf (fWrite, "\\n");
				break;

			case '\t':
				fprintf (fWrite, "\\t");
				break;

			default:

				fprintf (fWrite, "%c", pszBuffer[iPos]);
				break;
			}

			iPos ++;
		}
		
	} else {

		while (&(pszBuffer[iPos]) < pszOpen) {	
			
			switch (pszBuffer[iPos]) {
			case '\n':
				fprintf (fWrite, "\\n");
				break;

			case '\t':
				fprintf (fWrite, "\\t");
				break;

			default:

				fprintf (fWrite, "%c", pszBuffer[iPos]);
				break;
			}

			iPos ++;
		}
	}

	fprintf (fWrite, "\");");
}